#!/usr/bin/env python3
"""
Best by far
by Javantea
July 26, 2016

Find graphs that have much better performance.

python3 best_algorithm1.py |sort -k 8 -n >best_algorithm1a.txt
gawk '{print $1}' best_algorithm1a.txt |sort |uniq -c |sort -nr
   1890 right
    827 loop
    196 grid
    133 FruchtermanReingold
     84 lattice
     83 spiral
     49 branch
      1 random

"""
import numpy as np
import matplotlib.pyplot as plt
import sys

a = np.loadtxt('grid1testz49_50_51_53_54_55.txt.dat')
#cols = [[c[i] for c in a] for i in range(len(a[0]))]

fields = 'nodes conns branches branch V grid V spiral V lattice V linear V loop V right V random V FruchtermanReingold V seed'.split(' ')
Pots = 'branch grid spiral lattice linear loop right random FruchtermanReingold'.split(' ')
V_i = [i for i in range(len(fields)) if fields[i] == 'V']

for row in a:
	Potentials = [row[i] for i in V_i]
	for i, V_test in enumerate(Potentials):
		acceptable = True
		best_dV = Potentials[(i + 1) % len(Potentials)] - V_test
		for j, V_b in enumerate(Potentials):
			if i == j: continue
			dV = V_b - V_test
			if dV > V_test:
				# Acceptable
				best_dV = min(best_dV, dV)
			else:
				acceptable = False
				break
			#end if
		#next j, V_b
		if acceptable:
			print('%s is the best with %f by %f %f %% on %i %i %i %i' % (fields[V_i[i]-1], V_test, best_dV, 100.*(best_dV/V_test), row[0], row[1], row[2], row[-1]))
			break
		#end if
	#next i, V_test
#next row
