/*
l-bfgs-b Javascript
Conversion by Javantea
Feb 12, 2016
Code based on scipy/optimize/lbfgsb.py

## License for the Python wrapper
## ==============================

## Copyright (c) 2004 David M. Cooke <cookedm@physics.mcmaster.ca>

## Permission is hereby granted, free of charge, to any person obtaining a
## copy of this software and associated documentation files (the "Software"),
## to deal in the Software without restriction, including without limitation
## the rights to use, copy, modify, merge, publish, distribute, sublicense,
## and/or sell copies of the Software, and to permit persons to whom the
## Software is furnished to do so, subject to the following conditions:

## The above copyright notice and this permission notice shall be included in
## all copies or substantial portions of the Software.

## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
## FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
## DEALINGS IN THE SOFTWARE.

## Modifications by Travis Oliphant and Enthought, Inc. for inclusion in SciPy
*/

function np_einsum(algo, arr1, arr2)
{
	// FIXME: This function is crazy complicated.
	// We don't actually use the value ever, so why even bother?
	return 1;
}

/* class LbfgsInvHessProduct(LinearOperator):
* 
*/
function LbfgsInvHessProduct(sk, yk)
{
	// TODO: Shape.
	if (sk.length != yk.length) {
		throw Exception('sk and yk must have matching shape, (n_corrs, n)');
	}
	var n_corrs = sk.length;
	var n = sk[0].length;

	// TODO: whatever a linear operator is.
	//super(LbfgsInvHessProduct, self).__init__(
	//	dtype=np.float64, shape=(n, n))

	this.sk = sk;
	this.yk = yk;
	this.n_corrs = n_corrs;
	// TODO: numpy.einsum: Evaluates the Einstein summation convention on the operands.
	this.rho = 1 / np_einsum('ij,ij->i', sk, yk);
}
new LbfgsInvHessProduct([[1],[2]], [[1],[2]]);

/**
* 
* size must be the size in bytes, not in values!
* values must be an Int32Array, etc with values to store or null.
**/
function makeHeapArray(size, values)
{
	//debug("heap array: " + size + ", " + JSON.stringify(values));
	var APtr = Module._malloc(size);
	// Copy data to Emscripten heap (directly accessed from Module.HEAPU8)
	var AHeap = new Uint8Array(Module.HEAPU8.buffer, APtr, size);
	if (values != null) {
		if (values instanceof Array) {
			// FIXME: This code has never been tested.
			AHeap.set(new Uint8Array(values));
			debug("nonono: " + size + ", " + JSON.stringify(values));
		} else {
			AHeap.set(new Uint8Array(values.buffer));
			//debug("heap array set: " + size + ", " + JSON.stringify(values) + ", " + JSON.stringify(new Uint8Array(values.buffer)));
		}
	}
	return AHeap;
}

/*
 * Convert a Uint8Array into a string.
 */
function u8toString(v)
{
	var i;
	var ret = '';
	for (i = 0; i < v.length; i++) {
		ret += String.fromCharCode(v[i]);
	}
	return ret;
}

/*
 * Convert a string int a Uint8Array.
 */
function stringToU8(v)
{
	var i;
	var ret = new Uint8Array(v.length);
	for (i = 0; i < v.length; i++) {
		ret[i] = v[i].charCodeAt(0);
	}
	return ret;
}

var start_t = null;
function debugTime(x)
{
	if(start_t == null) {
		start_t = Date.now();
		debug('callback at 0');
		return;
	}
	var dt = Date.now() - start_t;
	debug('callback at ' + dt/1000);
}

/*
This tests it:

function minme(x)
{
  var a = x[0];
  var b = x[1];
  debug("minme("+a+", "+b+")");
  return (a|0) + (b|0);
}

res = _minimize_lbfgsb(minme, [5, 6], []);
debug(res.toSource())
*/

/**
* _minimize_lbfgsb(fun, x0, args=(), jac=None, bounds=None,
					disp=None, maxcor=10, ftol=2.2204460492503131e-09,
					gtol=1e-5, eps=1e-8, maxfun=15000, maxiter=15000,
					iprint=-1, callback=None, maxls=20, **unknown_options)
	Minimize a scalar function of one or more variables using the L-BFGS-B
	algorithm.

	Options
	-------
	disp : bool
	Set to True to print convergence messages.
	maxcor : int
		The maximum number of variable metric corrections used to
		define the limited memory matrix. (The limited memory BFGS
		method does not store the full hessian but uses this many terms
		in an approximation to it.)
	factr : float
		The iteration stops when ``(f^k -
		f^{k+1})/max{|f^k|,|f^{k+1}|,1} <= factr * eps``, where ``eps``
		is the machine precision, which is automatically generated by
		the code. Typical values for `factr` are: 1e12 for low
		accuracy; 1e7 for moderate accuracy; 10.0 for extremely high
		accuracy.
	ftol : float
		The iteration stops when ``(f^k -
		f^{k+1})/max{|f^k|,|f^{k+1}|,1} <= ftol``.
	gtol : float
		The iteration will stop when ``max{|proj g_i | i = 1, ..., n}
		<= gtol`` where ``pg_i`` is the i-th component of the
		projected gradient.
	eps : float
		Step size used for numerical approximation of the jacobian.
	disp : int
		Set to True to print convergence messages.
	maxfun : int
		Maximum number of function evaluations.
	maxiter : int
		Maximum number of iterations.
	maxls : int, optional
		Maximum number of line search steps (per iteration). Default is 20.
*/
function _minimize_lbfgsb(fun, x0, args, jac, bounds,
					disp, maxcor, ftol,
					gtol, eps, maxfun, maxiter,
					iprint, callback, maxls)
{
	//_check_unknown_options(unknown_options)
	if (args == undefined) { args = []; }
	if (jac == undefined) { jac = null; }
	if (bounds == undefined) { bounds = null; }
	if (disp == undefined) { disp = null; }
	if (maxcor == undefined) { maxcor = 10; }
	if (ftol == undefined) { ftol = 2.2204460492503131e-09; }
	if (gtol == undefined) { gtol = 1e-5; }
	if (eps == undefined) { eps = 1e-8; }
	if (maxfun == undefined) { maxfun = 15000; }
	if (maxiter == undefined) { maxiter = 15000; }
	if (iprint == undefined) { iprint = -1; } // NOTE: Temporary verboseness set this to 1.
	if (callback == undefined) { callback = null; }
	if (maxls == undefined) { maxls = 20; }
	var m = maxcor;
	var epsilon = eps;
	var pgtol = gtol;
	var factr = ftol / 2.2204460492503131e-16; // np.finfo(float).eps
	var task_str;
	// 10 seconds will get us the message, so stop at 9 seconds.
	// TODO: Worker instead.
	var time_limit = 9;
	
	//if (callback == null) {
	//	callback = debugTime;
	//}

	//x0 = asarray(x0).ravel()
	var n = x0.length;

	if (bounds === null) {
		// TODO: Validate
		bounds = new Array(n).fill([null, null]);
	}
	if (bounds.length != n) {
		throw Exception('length of x0 != length of bounds');
	}
	//# unbounded variables must use None, not +-inf, for optimizer to work properly
	// TODO: Validate
	//bounds = [(None if l == -np.inf else l, None if u == np.inf else u) for l, u in bounds];
	var bounds_r = [];
	var j;
	for (j = 0; j < bounds.length; j++) {
		var p = bounds[0];
		var q = bounds[1];
		if (p == -Infinity) { p = null; }
		if (q == -Infinity) { q = null; }
		bounds_r.push([p, q]);
	}

	if (disp != null) {
		if (disp == 0) {
			iprint = -1;
		} else {
			iprint = disp;
		}
	}

	n_function_evals = 0;
	// Unnecessary complexity
	//n_function_evals, fun = wrap_function(fun, ())
	var func_and_grad;
	if (jac == null) {
		func_and_grad = function(x) {
			// variable number of arguments
			var wrap_x = Array.from([x]);
			var f = fun.apply(this, wrap_x.concat(args));
			var xArr = Array.from(x);
			var g = _approx_fprime_helper(xArr, fun, epsilon, args, f);
			return [f, g];
		}
	} else {
		func_and_grad = function(x) {
			// variable number of arguments
			// TODO: Test this code, never tried before.
			var xArr = Array.from([x]);
			var xArrConcat = xArr.concat(args);
			var f = fun.apply(this, xArrConcat);
			var g = jac.apply(this, xArrConcat);
			return [f, g];
		}
	}
	// TODO: Tons of fixes to be done.
	var nbd = new Int32Array(n).fill(0); // int32
	var low_bnd = new Float64Array(n).fill(0); // float64)
	var upper_bnd = new Float64Array(n).fill(0); // float64)
	var bounds_map = {',': 0,
					'1,': 1,
					'1,1': 2,
					',1': 3};
	var i;
	for (i = 0; i < n; i++) {
		l = bounds[i][0];
		u = bounds[i][1];
		if (l != null) {
			low_bnd[i] = l;
			l = 1;
		}
		if (u != null) {
			upper_bnd[i] = u;
			u = 1;
		}
		nbd[i] = bounds_map[[l, u].toString()];
	}
	if (maxls <= 0) {
		throw Exception('maxls must be positive.');
	}

	var x = makeHeapArray(n*Float64Array.BYTES_PER_ELEMENT, Float64Array.from(x0)); // float64
	var f = makeHeapArray(Float64Array.BYTES_PER_ELEMENT, Float64Array.from([0.0])); // float64
	var g = makeHeapArray(n*Float64Array.BYTES_PER_ELEMENT, new Float64Array(n).fill(0)); // float64
	var wa = makeHeapArray((2*m*n + 5*n + 11*m*m + 8*m)*Float64Array.BYTES_PER_ELEMENT, new Float64Array(2*m*n + 5*n + 11*m*m + 8*m).fill(0)); // float64)
	var iwa = makeHeapArray(3*n*Int32Array.BYTES_PER_ELEMENT, new Int32Array(3*n).fill(0)); // int32)
	// TODO: Verify that this is the right allocation for a string.
	var task = makeHeapArray(60, new Uint8Array(60).fill(0)); // 'S60') # String of length 60
	var csave = makeHeapArray(60, new Uint8Array(60).fill(0)); // 'S60') # String of length 60
	var lsave = makeHeapArray(4*Int32Array.BYTES_PER_ELEMENT, new Int32Array(4).fill(0)); // int32)
	var isave = makeHeapArray(44*Int32Array.BYTES_PER_ELEMENT, new Int32Array(44).fill(0)); // int32)
	var dsave = makeHeapArray(29*Float64Array.BYTES_PER_ELEMENT, new Float64Array(29).fill(0)); // float64)
	var pgtol_ptr = makeHeapArray(Float64Array.BYTES_PER_ELEMENT, Float64Array.from([pgtol])); // float64)
	//setValue(pgtol_ptr.byteOffset, pgtol, 'double');
	var low_bnd_ptr = makeHeapArray(n*Float64Array.BYTES_PER_ELEMENT, low_bnd); // float64)
	var upper_bnd_ptr = makeHeapArray(n*Float64Array.BYTES_PER_ELEMENT, upper_bnd); // float64)
	var nbd_ptr = makeHeapArray(n*Int32Array.BYTES_PER_ELEMENT, nbd); // int32)
	var iprint_ptr = makeHeapArray(Int32Array.BYTES_PER_ELEMENT, Int32Array.from([iprint])); // int32)
	var maxls_ptr = makeHeapArray(Int32Array.BYTES_PER_ELEMENT, Int32Array.from([maxls])); // int32)
	var n_ptr = makeHeapArray(Int32Array.BYTES_PER_ELEMENT, Int32Array.from([n])); // int32)
	var m_ptr = makeHeapArray(Int32Array.BYTES_PER_ELEMENT, Int32Array.from([m])); // int32)

	task.set(stringToU8('START'));
	task_str = u8toString(Array.from(task));
	//debug("did set work? " + task_str); // It seems like it did, but...

	var n_iterations = 0;
	
	var start_t = Date.now();
	var dt;

	while (1) {
		//# x, f, g, wa, iwa, task, csave, lsave, isave, dsave = \
		// $n is not in the code that I can see, so whatever.
		_setulb_(n_ptr.byteOffset, m_ptr.byteOffset, x.byteOffset, low_bnd_ptr.byteOffset, upper_bnd_ptr.byteOffset, nbd_ptr.byteOffset, f.byteOffset, g.byteOffset, factr.byteOffset,
					pgtol_ptr.byteOffset, wa.byteOffset, iwa.byteOffset, task.byteOffset, iprint_ptr.byteOffset, csave.byteOffset, lsave.byteOffset,
					isave.byteOffset, dsave.byteOffset, maxls_ptr.byteOffset);
		task_str = u8toString(Array.from(task));
		//debug("task_str: " + task_str);
		var isArr = new Int32Array(isave.buffer, isave.byteOffset, 44);
		var lsArr = new Int32Array(lsave.buffer, lsave.byteOffset, 4);
		var dsArr = new Float64Array(isave.buffer, isave.byteOffset, 29);
		//debug("isave: " + JSON.stringify(isArr));
		//debug("lsave: " + JSON.stringify(lsArr));
		//debug("dsave: " + JSON.stringify(dsArr));
		if (task_str.startsWith('FG')) {
			if (n_function_evals > maxfun) {
				task.set(stringToU8('STOP: TOTAL NO. of f AND g EVALUATIONS ' +
						'EXCEEDS LIMIT'));
			} else {
				//# minimization routine wants f and g at the current x
				//# Overwrite f and g:
				// FIXME: this isn't standard, but I'm in a hurry, standard > hurry.
				var Xout = new Float64Array(x.buffer, x.byteOffset, n);
				var res_f_g = func_and_grad(Xout);
				//debug('fg=:' + res_f_g[0] + " " + JSON.stringify(res_f_g[1]));
				f.set(new Uint8Array(Float64Array.from([res_f_g[0]]).buffer));
				//setValue(f, res_f_g[0], 'double');
				g.set(new Uint8Array(Float64Array.from(res_f_g[1]).buffer));
				//g.set(new Uint8Array(Float64Array.from([1e26,1e24]).buffer));
				//debug('fg:' + f.byteOffset + " " + g.byteOffset + " " + getValue(f.byteOffset, 'double') + " " + getValue(g.byteOffset, 'double') + " " + getValue(g.byteOffset+8, 'double'));
				n_function_evals++;
			}
		} else if (task_str.startsWith('NEW_X')) {
			//# new iteration
			if (n_iterations > maxiter) {
				task.set(stringToU8('STOP: TOTAL NO. of ITERATIONS EXCEEDS LIMIT'));
			} else {
				n_iterations++;
				if (callback != null) {
					callback(x);
				}
			}
		} else {
			break;
		}
		dt = Date.now() - start_t;
		if ((dt/1000.) > time_limit) {
			// Time is up, go unfinished or restart later.
			task.set(stringToU8('STOP: time limit exceeded, restart to attempt finish'));
		}
	}
	// TODO: strip
	task_str = u8toString(Array.from(task));
	if (task_str.startsWith('CONV')) {
		warnflag = 0;
	} else if (n_function_evals > maxfun) {
		warnflag = 1;
	} else if (n_iterations > maxiter) {
		warnflag = 1;
	} else {
		warnflag = 2;
	}
	dt = Date.now() - start_t;

	/*
	// FIXME: This silliness is not used at all, why scipy?
	//# These two portions of the workspace are described in the mainlb
	//# subroutine in lbfgsb.f. See line 363.
	var s = reshape(wa.slice(0, m*n), m, n);
	var y = reshape(wa.slice(m*n, 2*m*n), m, n);
	*/

	//# See lbfgsb.f line 160 for this portion of the workspace.
	//# isave(31) = the total number of BFGS updates prior the current iteration;
	var n_bfgs_updates = getValue(isave+30, 'i32');
	//debug('n_bfgs_updates: ' + n_bfgs_updates);

	var n_corrs = Math.min(n_bfgs_updates, maxcor);
	var hess_inv = null;
	/*
	if (n_corrs > 0) {
		hess_inv = LbfgsInvHessProduct(s.slice(0, n_corrs), y.slice(0, n_corrs));
	}
	*/
	

	var gArr = new Float64Array(g.buffer, g.byteOffset, n);
	var xArr = new Float64Array(x.buffer, x.byteOffset, n);
	var fArr = new Float64Array(f.buffer, f.byteOffset, 1);
	// FIXME: when we free, the data we've "copied" becomes corrupt.
	//Module._free(x.byteOffset);
	//Module._free(f.byteOffset);
	//Module._free(g.byteOffset);
	Module._free(wa.byteOffset);
	Module._free(iwa.byteOffset);
	Module._free(task.byteOffset);
	Module._free(csave.byteOffset);
	Module._free(isave.byteOffset);
	Module._free(dsave.byteOffset);
	Module._free(pgtol_ptr.byteOffset);
	Module._free(low_bnd_ptr.byteOffset);
	Module._free(upper_bnd_ptr.byteOffset);
	Module._free(nbd_ptr.byteOffset);
	Module._free(iprint_ptr.byteOffset);
	Module._free(maxls_ptr.byteOffset);
	Module._free(n_ptr.byteOffset);
	Module._free(m_ptr.byteOffset);
	// TODO: OptimizeResult class
	return {fun:fArr, jac:gArr, nfev:n_function_evals,
						nit:n_iterations, status:warnflag, message:task_str,
						x:xArr, success:(warnflag == 0), hess_inv:hess_inv, dt:dt/1000};
}

/**
* _approx_fprime_helper(xk, f, epsilon, args=(), f0=None)
* From scipy/optimize/optimize.py
	See ``approx_fprime``.  An optional initial function value arg is added.
*/
function _approx_fprime_helper(xk, f, epsilon, args, f0)
{
	if (args == undefined) { args = []; }
	if (f0 == undefined) { f0 = null; }
	if (f0 == null) {
		// variable args
		var wrap_xk = [xk];
		f0 = f.apply(this, wrap_xk.concat(args));
	}
	//debug('f0: ' + f0 + ", xk: " + JSON.stringify(xk));
	var grad = new Float32Array(xk.length).fill(0); // float
	var ei = new Float32Array(xk.length).fill(0); // float
	var k;
	for (k = 0; k < xk.length; k++) {
		ei[k] = 1.0;
		var d = new Float32Array(xk.length);
		var d_plus_xk = new Array(xk.length);
		var m;
		for (m = 0; m < xk.length; m++) {
			d[m] = epsilon * ei[m];
			d_plus_xk[m] = d[m] + xk[m];
			//debug("Computed: " + d_plus_xk[m]);
		}
		var wrap_dxk = [d_plus_xk].concat(args);
		//debug("Found wrap: " + JSON.stringify(wrap_dxk));
		grad[k] = ((f.apply(this, wrap_dxk)) - f0) / d[k];
		//if(grad[k] > 100) debug("wdxk: " + JSON.stringify(wrap_dxk) + ", xk: " + JSON.stringify(xk) + ", d[k]: " + d[k] + ", f0: " + f0 + ", f: " + f.apply(this, wrap_dxk));
		ei[k] = 0.0;
		//debug("Grad: " + JSON.stringify(grad));
	}
	return grad;
}
