#!/usr/bin/env python3
"""
traceroute1.py
by Javantea
June 1, 2007

Does traceroutes.
Usage:
python traceroute1.py [domain name] [IP]
auto interrupts on timeout
You can get the raw traceroute data that it's using by looking at the last line 
of the svg. It gives the filename where it it stored. It will be in the current 
directory and look like traceroute1_b86Shh.txt

TODO: 
"""
from __future__ import print_function
import re
import subprocess
import sys

def traceRouteLines(names, flags = ''):
	"""
	Executes traceroutes and puts the results in an array.
	It auto interrupts on timeout.
	FIXME: It loses any stderr after the second.
	"""
	noresp = re.compile(b'\* \* \*')
	
	flagl = []
	if flags != '':
		flagl = [flags]
	#end if
	
	data = []
	for name in names:
		p = subprocess.Popen(["traceroute"] + flagl + [name], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
		output = [p.stderr.readline()]
		missing1 = 0
		while True:
			d = p.stdout.readline()
			if d == b'':
				break
			elif noresp.search(d):
				missing1 += 1
			else:
				missing1 = 0
			#end if
			# three in a row missed means that we're done.
			if missing1 == 3:
				break
			#end if
			output.append(d)
		#loop
		#e = '#'
		#while e != '':
		#e = p.stderr.readline()
		#if e != '': output.append(e)
		#loop
		#output.append(p.stderr.read())
		data.append(b'\n'.join(output))
	#next url
	return data
#end def traceRouteLines(names, flags)

def main(output = 'svg'):
	"""
	The main function.
	output = svg | raw | py
	"""
	
	urls = ['www.google.com', 'www.yahoo.com', 'www.altsci.com', 
	'www.microsoft.com', 'en.wikipedia.org', 'www.playstation.com', 'www.sony.net', 
	'www.scei.co.jp', 'slashdot.org', 'www.theplanet.com']
	
	#urls = ['www.yahoo.com', 'en.wikipedia.org']
	
	if len(sys.argv) > 1:
		if '-py' in sys.argv:
			output = 'py'
			sys.argv.remove('-py')
		elif '-raw' in sys.argv:
			output = 'raw'
			sys.argv.remove('-raw')
		#end if
		if len(sys.argv) > 1:
			urls = sys.argv[1:]
		#end if
	#end if
	
	data = traceRouteLines(urls)
	
	if output == 'svg':
		import routemap1
		import tempfile
		a = tempfile.mkstemp('.txt', 'traceroute1_', './data/')
		filename = a[1]
		f = open(filename, 'wb')
		f.write(b'\n'.join(data))
		f.close()
		rseed = 403
		m = routemap1.createRouteMap(filename, rseed)
		b = tempfile.mkstemp('.svg', 'traceroute1_', './data/')
		svgFilename = b[1]
		open(svgFilename, 'wb').write(m)
		print('Temp file with traceroutes written to:', filename)
		print('SVG written to:', svgFilename)
	else:
		if output == 'py':
			print('d = []')
		#end if
		test = r' ?(\d+)  ([^ ]+) \(([^\)]+)\) +(\d*\.?\d* ms) +(\d*\.?\d* ms) +(\d*\.?\d* ms)'
		prog = re.compile(test)
		for line in data:
			if output == 'raw':
				print(line.decode('utf-8'))
			elif output == 'py':
				found = prog.finditer(line)
				for d in found:
					print('d.append(', d.groups(), ')')
				#next d
			else:
				print('What did you want the output to be?')
				break
			#end if
		#next d
	#end if
#end def main()

if __name__ == '__main__':
	main()
#end if

	
